//+------------------------------------------------------------------+
//|                                             Aces70 with push.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "aces70"
#property link      "http://www.mql4.com"
#property version   "1.00"
#property strict

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 clrMediumSeaGreen
#property indicator_color2 clrMediumSeaGreen
#property indicator_color3 clrMediumSeaGreen
#property indicator_color4 clrGold
#property indicator_color5 clrRed
#property indicator_color6 clrRed
#property indicator_color7 clrGold
input string parameter="Input Parameter ";//<><><><><><><>
//---- input parameters
extern int gap = 30;
input int          period=20;          // averaging period
input double       deviation= 2;       // standard deviations
input int          bands_shift=0;      // bands shift
input ENUM_APPLIED_PRICE          applied_price=0;   // applied price
input int          ma_period=7;        // MA averaging period
input int          ma_shift=0;         // MA shift
input ENUM_MA_METHOD ma_method=1;        // MA averaging method
input ENUM_APPLIED_PRICE maapplied_price=1;    // MA applied price
input double FilterDV=4;// Filter Max Dev (%)

input string TFilter="Time Filter";//<><><><><><><>

input bool UseTimeFilter=true;
input string StartTrade="1:35";
input string EndTrade="17:15";
input string Alert__="Alert";//<><><><><><><>
input bool EmailAlert=True;
// inputs of Push Notification
input string Notification = " Push Notification Settings";
input  bool  Push_Notification = True;
 

//input string Message="BB MA Cross ";//Comment Alert
input string LABEL="LABEL";//<><><><><><><>
input string FontName = "Verdana";
input int    FontSize = 7;
input ENUM_BASE_CORNER    TextCorner=1;
input color  TextColor=clrWhite;
input color  HeaderColor = clrWhite;
input int    TextXAnchor = 15;
input int    TextYAnchor = 18;
input string Author="Aces 70";
input bool Display1=false;
input bool Display2=false;
input bool Display3=false;
input bool Display4=false;
input bool Display5=false;
input bool Display6=false;
input bool SignalLine = true;
bool ShowDev=false;//displays the value of dev
string lbl="Aces 70";
string sa="";
string sb="";

int ExtStdDevMAMethod=0;
int ExtStdDevPeriod=period;
int ExtStdDevAppliedPrice=applied_price;
int ExtStdDevShift=bands_shift;
//---- buffers
//double ExtStdDevBuffer[];

//---- indicator buffers
double BBUP[];
double BBDW[];
double BBSMA[];
double BBDVE[];
double EXMA[];
double BBDV[];
double XMAUP[];
double XMADW[];
int bar=Bars;
double g_price_88;
double g_price_128;
double gd_160;
double gd_168;
bool gi_192;
datetime some_time;
int b,s;
datetime lasttime;
bool    email=false;
datetime time=Time[0];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {//ObjectsDeleteAll();
//---- line shifts when drawing
   SetIndexShift(0,0);
   SetIndexShift(1,0);
   SetIndexShift(2,0);
   SetIndexShift(3,0);
   SetIndexShift(4,0);
   SetIndexShift(5,0);
   SetIndexShift(6,0);
   SetIndexShift(7,0);

//---- first positions skipped when drawing
   SetIndexDrawBegin(0,period-1);
   SetIndexDrawBegin(1,period-1);
   SetIndexDrawBegin(2,period-1);
   SetIndexDrawBegin(3,period-1);

   SetIndexDrawBegin(4,ma_period-1);
   SetIndexDrawBegin(5,ma_period-1);
   SetIndexDrawBegin(6,ma_period-1);
   SetIndexDrawBegin(7,ma_period-1);

//---- 3 indicator buffers mapping
   SetIndexBuffer(0,BBUP);
   SetIndexBuffer(1,BBDW);
   SetIndexBuffer(2,BBSMA);
   SetIndexBuffer(3,BBDVE);

   SetIndexBuffer(4,EXMA);
   SetIndexBuffer(5,XMAUP);
   SetIndexBuffer(6,XMADW);
   SetIndexBuffer(7,BBDV);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE,2,3);
   SetIndexStyle(4,DRAW_LINE);
//   SetIndexStyle(4,DRAW_NONE);
//  SetIndexArrow(4,1);

   SetIndexStyle(6,DRAW_NONE);

//---- index labels
   SetIndexLabel(0,"BB Upper");
   SetIndexLabel(1,"BB Lowwer");
   SetIndexLabel(2,"BB Main");
   SetIndexLabel(3,"Exp MA");
   SetIndexLabel(4,"BB devS");
   SetIndexLabel(5,"Cross Up");
   SetIndexLabel(6,"Cross Dw");
   SetIndexLabel(7,"BB dev");
   

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()
  {
   ObjectsDeleteAll();
   return(0);
  }
//+------------------------------------------------------------------+
//| Bill Williams' Alligator                                         |
//+------------------------------------------------------------------+

double konst=1/Point;//0000;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   DisplayInfo();
   
   if(Volume[0]<3) { b=0; s=0; }
   
   int    i,j,nCountedBars;
   double dAPrice,dAmount,dMovingAverage;

   double c=0.1*TFc();
   if(Digits==4) c=1*TFc();
   if(Digits==3) c=0.1*TFc();
   if(Digits==2) c=1*TFc();

   double ma1=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_MAIN,1);
   double ma2=iMA(Symbol(),0,ma_period,ma_shift,ma_method,maapplied_price,1);
   double ma12=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_MAIN,2);
   double ma22=iMA(Symbol(),0,ma_period,ma_shift,ma_method,maapplied_price,2);
   double bbu=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_UPPER,2);
   double bbd=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_LOWER,2);
   
   if(bar!=Bars)
      //    if(dev<FilterDV)
     {
      if(BBDVE[0]!=EMPTY_VALUE && BBDVE[1]==EMPTY_VALUE)peringatan2(" Start SD = "+DoubleToStr(BBDV[2],2));
      if(BBDVE[0]==EMPTY_VALUE && BBDVE[1]!=EMPTY_VALUE)peringatan2(" End SD = "+DoubleToStr(BBDV[2],2));
      
      if(BBDV[2]<FilterDV)
         if(TimeTrade2(0))
           {
            if(BBDVE[0]!=EMPTY_VALUE && BBDVE[1]==EMPTY_VALUE)peringatan2(" Start SD = "+DoubleToStr(BBDV[2],2));
            if(BBDVE[0]==EMPTY_VALUE && BBDVE[1]!=EMPTY_VALUE)peringatan2(" End SD = "+DoubleToStr(BBDV[2],2));
            
      }
            if(ma1>ma2)
               if(ma12<=ma22)
                 {
                  peringatan2(" Dw SD = "+DoubleToStr(BBDV[2],2));
                 }

            if(ma1<ma2)
               if(ma12>=ma22)
                 {
                  peringatan2(" Up SD = "+DoubleToStr(BBDV[2],2));
                 }        
      if(BBDVE[1]==EMPTY_VALUE && BBDVE[2]!=EMPTY_VALUE){
      g_price_88 = bbd-gap*Point;g_price_128 = bbu+gap*Point;
      some_time=Time[0];
      if (SignalLine == true)peringatan3(" Alert line is drawn : ");}
      int shift=iBarShift(NULL,0,some_time);
      double bbsu = iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_UPPER,shift);
      double bbsd = iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_LOWER,shift);
      if((bbsd-gap*Point)>Low[0] && (bbsd-gap*Point)<Close[1]){peringatan4(" Alert line is Crossed : ");}
      if((bbsu+gap*Point)<High[0] && (bbsu+gap*Point)>Close[1]){peringatan5(" Alert line is Crossed : ");}
      gd_160 = bbu-bbd;
      if (gd_168 != gd_160) {
      ObjectDelete("Buy");
      ObjectDelete("Buy_label");
      ObjectDelete("Sell");
      ObjectDelete("Sell_label");
      gi_192 = FALSE;
      gd_168 = gd_160;
   
      if (SignalLine == true && gi_192 == FALSE) {
      ObjectCreate("Buy", OBJ_HLINE, 0, Time[40], g_price_88);
      ObjectSet("Buy", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("Buy", OBJPROP_COLOR, Red);
      ObjectCreate("Buy_label", OBJ_TEXT, 0, Time[0], g_price_88);
      ObjectSetText("Buy_label", "                             SELL", 8, "Times", Red);
      ObjectCreate("Sell", OBJ_HLINE, 0, Time[40], g_price_128);
      ObjectSet("Sell", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("Sell", OBJPROP_COLOR, GreenYellow);
      ObjectCreate("Sell_label", OBJ_TEXT, 0, Time[0], g_price_128);
      ObjectSetText("Sell_label", "                             BUY", 8, "Times", GreenYellow);  }}}
//---- insufficient data
   if(Bars<=ExtStdDevPeriod) return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//----Standard Deviation calculation
   i=Bars-ExtStdDevPeriod-1;
   if(nCountedBars>ExtStdDevPeriod)
      i=Bars-nCountedBars;
// i=100;
// while(i>=0)
   datetime timealert=iTime(Symbol(),240,0);
   for(i=i;i>=0;i--)
     {
      // if(i<2000)
        {

         double close[];// =Close[i];
         //---- ma_shift set to 0 because SetIndexShift called abowe
         BBUP[i]=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_UPPER,i);
         BBDW[i]=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_LOWER,i);
         EXMA[i]=iMA(Symbol(),0,ma_period,ma_shift,ma_method,maapplied_price,i);
         dAmount=0.0;
         dMovingAverage=iMA(NULL,0,ExtStdDevPeriod,0,ExtStdDevMAMethod,ExtStdDevAppliedPrice,i);
         for(j=0; j<ExtStdDevPeriod; j++)
           {
            dAPrice=GetAppliedPrice(ExtStdDevAppliedPrice,i+j);
            dAmount+=(dAPrice-dMovingAverage)*(dAPrice-dMovingAverage);
           }
         //         ExtStdDevBuffer[i]=MathSqrt(dAmount/ExtStdDevPeriod);
         BBDV[i]=NormalizeDouble(MathSqrt(dAmount/ExtStdDevPeriod)*konst*c,2);
         //      if(BBDV[i]>FilterDV)
           {
            BBSMA[i]=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_MAIN,i);
            BBDVE[i]=EMPTY_VALUE;
           }
         if(BBDV[i]<FilterDV)
           {
            BBDVE[i]=iBands(Symbol(),0,period,deviation,bands_shift,applied_price,MODE_MAIN,i);
            //   BBSMA[i]=EMPTY_VALUE;
           }
           
    
         
         int sif=1;
         string mytime=TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeToStr(TimeCurrent(),TIME_MINUTES);
         if(BBDV[sif+i+1]<=FilterDV)
            if(TimeTrade2(i))
              {
               if(EXMA[sif+i]>BBSMA[sif+i])
                  if(EXMA[sif+i+1]<=BBSMA[sif+i+1])
                    {
                     XMAUP[sif+i]=EXMA[sif+i];
                     string ANc="BUY"+TimeToStr(Time[i+1]);
                     string ANd="BUY"+IntegerToString(i+2);
                     string AN="SD."+DoubleToStr(BBDV[sif+i+1],2);
                     if(ObjectGet(ANc,OBJPROP_PRICE1)==0)
                       {
                        ObjectDelete(ANd);
                        if(ShowDev) gbr2(AN+"dev ",AN,Time[sif+i+1],BBDW[sif+i+1],clrWhite);
                        gbr(ANc,AN,Time[sif+i],EXMA[sif+i+1],1,clrBlue);
                        
                        //if(EmailAlert && b==0 && bar!=Bars) {
                        if(EmailAlert && b==0 && TimeCurrent()>=timealert && email) {
                        //string imsg=Symbol()+" "+DoubleToStr(Period(),0)+" EMA has crossed UP "+DoubleToStr(EXMA[sif+i+1],Digits)+" at "+TimeCurrent();
                        
                         string imsg=Symbol()+" "+DoubleToStr(Period(),0)+" EMA has crossed UP "+DoubleToStr(Close[0],Digits)+" at "+mytime;
                              SendMail(imsg,imsg);
                          // Alert("haha ",TimeCurrent());
                           lasttime=timealert;
                           b=1;
                           }
                       }
                    }
               if(EXMA[sif+i]<BBSMA[sif+i])
                  if(EXMA[sif+i+1]>=BBSMA[sif+i+1])
                    {
                     XMADW[sif+i]=EXMA[sif+i];
                     string ANn="Sell"+TimeToStr((Time[i+1]));
                     string ANe="Sell"+IntegerToString(i+2);
                     string ANs="SD "+DoubleToStr(BBDV[sif+i+1],2);
                     if(ObjectGet(ANn,OBJPROP_PRICE1)==0)
                       {
                        ObjectDelete(ANe);
                        if(ShowDev) gbr2(ANn+"dev",ANs,Time[sif+i+1],BBUP[sif+i+1],clrWhite);
                        gbr(ANn,ANs,Time[sif+i],EXMA[sif+i+1],11,clrRed);
                        
                       // if(EmailAlert && s==0 && bar!=Bars) {
                        if(EmailAlert && s==0 && TimeCurrent()>=timealert && email) {
                        string imsg=Symbol()+" "+DoubleToStr(Period(),0)+" EMA has crossed DOWN "+DoubleToStr(Close[0],Digits)+" at "+mytime;
                           SendMail(imsg,imsg);
                          // Alert("haha ",TimeCurrent());
                           lasttime=timealert;
                           s=1;
                           }
                           
                       }

                    }
               }
          }
     }
   
   email=True;
//---- done
//   DisplayInfo();
   return(0);
  }
//+------------------------------------------------------------------+
double GetAppliedPrice(int nAppliedPrice,int nIndex)
  {
   double dPrice;
//----
   switch(nAppliedPrice)
     {
      case 0:  dPrice=Close[nIndex];                                  break;
      case 1:  dPrice=Open[nIndex];                                   break;
      case 2:  dPrice=High[nIndex];                                   break;
      case 3:  dPrice=Low[nIndex];                                    break;
      case 4:  dPrice=(High[nIndex]+Low[nIndex])/2.0;                 break;
      case 5:  dPrice=(High[nIndex]+Low[nIndex]+Close[nIndex])/3.0;   break;
      case 6:  dPrice=(High[nIndex]+Low[nIndex]+2*Close[nIndex])/4.0; break;
      default: dPrice=0.0;
     }
//----
   return(dPrice);
  }
//+------------------------------------------------------------------+
void DisplayInfo()
  {
//------------------------------------------------------------------
   int index=3;
   if(Display1)
     {
      //------------------------------------------------------------------
      DrawLabel(lbl+IntegerToString(index),TextXAnchor,TextYAnchor*index,HeaderColor);
      SetText(lbl+IntegerToString(index),WindowExpertName(),FontSize,FontName);
      index++;
      //------------------------------------------------------------------
      DrawLabel(lbl+IntegerToString(index),TextXAnchor,TextYAnchor*index,HeaderColor);
      SetText(lbl+IntegerToString(index),"*** "+Author+" ***",FontSize,FontName);
      index++;
     }
//------------------------------------------------------------------
   if(Display2)
     {
      DrawLabel(lbl+IntegerToString(index),TextXAnchor,TextYAnchor*index,TextColor);
      SetText(lbl+IntegerToString(index),"SD: "+DoubleToStr(BBDV[0],2)+" %",FontSize,FontName);
      index++;
     }
//------------------------------------------------------------------
   if(Display3)
     {
      DrawLabel(lbl+IntegerToString(index),TextXAnchor,TextYAnchor*index,TextColor);
      SetText(lbl+IntegerToString(index),"Filter: "+DoubleToStr(FilterDV,2)+" %",FontSize,FontName);
      index++;
     }
//------------------------------------------------------------------
   datetime x=StrToTime(StartTrade);
   string y=TimeToStr(x,TIME_MINUTES);
   if(Display4)
     {
      DrawLabel(lbl+IntegerToString(index),TextXAnchor,TextYAnchor*index,TextColor);
      SetText(lbl+IntegerToString(index),"Start Trade: "+(y),FontSize,FontName);
      index++;
     }
//------------------------------------------------------------------
   if(Display5)
     {
      x=StrToTime(EndTrade);
      y=TimeToStr(x,TIME_MINUTES);
      DrawLabel(lbl+IntegerToString(index),TextXAnchor,TextYAnchor*index,TextColor);
      SetText(lbl+IntegerToString(index),"End Trade: "+(y),FontSize,FontName);
      index++;
     }
//------------------------------------------------------------------*/

   y=TimeToStr(TimeCurrent(),TIME_MINUTES);
   if(Display6)
     {
      DrawLabel(lbl+IntegerToString(index),TextXAnchor,TextYAnchor*index,TextColor);
      SetText(lbl+IntegerToString(index),"Now: "+(y),FontSize,FontName);
      index++;
     }
//------------------------------------------------------------------*/
  }
//+------------------------------------------------------------------+
void RemoveInfo()
  {
   for(int i=1; i<30; i++)
      if(ObjectFind(lbl+IntegerToString(i))!=-1) ObjectDelete(lbl+IntegerToString(i));
  }
//+------------------------------------------------------------------+
void DrawLabel(string name,int x,int y,color col)
  {
   if(ObjectFind(0,name)==-1)
     {
      ObjectCreate(0,name,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,name,OBJPROP_BACK,false);
      ObjectSetInteger(0,name,OBJPROP_CORNER,TextCorner);
      if(TextCorner==0 || TextCorner==2) ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_LEFT);
      else ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_RIGHT);
     }
   if(ObjectGetInteger(0, name, OBJPROP_XDISTANCE) != x) ObjectSetInteger(0, name, OBJPROP_XDISTANCE, x);
   if(ObjectGetInteger(0, name, OBJPROP_YDISTANCE) != y) ObjectSetInteger(0, name, OBJPROP_YDISTANCE, y);
   if(ObjectGetInteger(0,name,OBJPROP_COLOR)!=col) ObjectSetInteger(0,name,OBJPROP_COLOR,col);
  }
//+------------------------------------------------------------------+
void SetText(string name,string text,int size,string font,color col=clrNONE)
  {
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,size);
   if(col!=clrNONE) ObjectSetInteger(0,name,OBJPROP_COLOR,col);
   ObjectSetString(0,name,OBJPROP_FONT,font);
   ObjectSetString(0,name,OBJPROP_TEXT,text);
   if(TextCorner==0 || TextCorner==2) ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_LEFT);
   else ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_RIGHT);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void gbr(string nama,string tex,datetime tempat,double harga1,int kode,color warna)
  {
   if(kode==1)
     {
      ObjectCreate(nama,OBJ_ARROW_BUY,0,tempat,harga1);
      ObjectSetText(nama,tex,11,NULL,warna);
      ObjectSet(nama,OBJPROP_COLOR,warna);
      ObjectSet(nama,OBJPROP_SELECTABLE,False);
      if(Push_Notification == True){
      
      if(Time[0]> time){
      
      SendNotification(_Symbol+" M"+IntegerToString(_Period)+" EMA has crossed UP at "+ TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
Sleep(3000);   
     }
     }
     
     }
     
   if(kode==11)
     {
      ObjectCreate(nama,OBJ_ARROW_SELL,0,tempat,harga1);
      ObjectSetText(nama,tex,11,NULL,warna);
      ObjectSet(nama,OBJPROP_COLOR,warna);
      ObjectSet(nama,OBJPROP_SELECTABLE,False);
      
           if(Push_Notification == True){
      
      if(Time[0]> time){
      
      SendNotification(_Symbol+" M"+IntegerToString(_Period)+" EMA has crossed DOWN at "+ TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS));
      Sleep(3000);
    }
     } 
      
     }
  }
//+------------------------------------------------------------------+
void gbr2(string nama,string tex,datetime tempat,double harga1,color warna)
  {
   ObjectCreate(nama,OBJ_TEXT,0,tempat,harga1);
   ObjectSetText(nama,tex,7,NULL,warna);
   ObjectSetDouble(0,nama,OBJPROP_ANGLE,90);
   ObjectSet(nama,OBJPROP_SELECTABLE,False);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string mess2="";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void peringatan2(string a)
  {
   return;
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void peringatan3(string a)
  {

   return;
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void peringatan4(string a)
  {

   return;
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void peringatan5(string a)
  {

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double TFc()
  {
   int a=Period();
   if(a==1)return(10);
   if(a==5)return(4);
   if(a==15)return(1);
   if(a==30)return(1);
   if(a==60)return(1);
   if(a==240)return(0.3);
   if(a==1440)return(0.1);
   if(a==10080)return(0.001);
   if(a==43200)return(0.0001);
   return(0);
  }
//+------------------------------------------------------------------+
bool TimeTrade()
  {
   string now=TimeToStr(TimeCurrent(),TIME_SECONDS);
   datetime saiki=StrToTime(now);
   datetime mulai=StrToTime(StartTrade);
   datetime mari=StrToTime(EndTrade);

   if(!UseTimeFilter)return true;
   if(saiki>mulai&&saiki<mari)return true;
   return false;

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool TimeTrade2(int i)
  {

   string now=TimeToStr(Time[i],TIME_SECONDS);
   datetime saiki=StrToTime(now);

   datetime mulai=StrToTime(StartTrade);
   datetime mari=StrToTime(EndTrade);

   if(!UseTimeFilter)return true;
   if(mulai<mari)
      if(saiki>mulai&&saiki<mari)return true;
   if(mulai>mari)
      if(saiki>mulai||saiki<mari)return true;

   return false;

  }
//+------------------------------------------------------------------+
